{% extends "templates/base.html" %}

{% block main %}
<h4>Publish your project</h4>
<div class="row">
  <div class="col s12 status">
    Logged in as: <span>{{ userData.name }}</span>
  </div>
</div>
{% if project.public_url %}
<div class="row">
  <div class="col s12 status">
    <p>
      This project is currently published at:<br> <a href="{{ project.public_url }}" target="_blank">{{ project.public_url }}</a>
    </p>
    {% if not canPublish %}
    <p>
      You do not have access to publish this project because it has been published by another user.
    </p>
    <p>
      <strong>Project owner:</strong> {{ project.owner_name }}
      {% if project.owner_email %}&lt;{{ project.owner_email }}&gt;{% endif %}
    </p>
    {% endif %}
  </div>
</div>
{% endif %}

{% if canPublish %}
  {% if error %}
  <div class="row">
    <div class="error col s12">
      Error: {{ error }}
    </div>
  </div>
  {% endif %}
  <form method="post" action=".">
    <input type="hidden" name="uuid" value="{{ formData.uuid }}">
    <div class="row">
      <div class="input-field col s12 name">
        <input type="text" name="name" id="name" value="{{ formData.name }}" required class="validate"></input>
        <label for="name">Project name*</label>
        <span class="helper-text"></span>
      </div>
    </div>
    <div class="row">
      <div class="input-field col s12 slug">
        <input type="text" name="slug" id="slug" value="{{ formData.slug }}" required class="validate"></input>
        <label for="slug">Domain name*</label>
        <span class="helper-text" data-error="" data-success="">
          {% if formData.slug %}
            {{ formData.slug }}.{{ PROJECT_BASE_DOMAIN }}
          {% else %}
            example.{{ PROJECT_BASE_DOMAIN }}
          {% endif %}
        </span>
      </div>
    </div>
    <div class="row">
      <div class="input-field col s12 description">
        <textarea name="description" id="description" class="materialize-textarea">{{ formData.description }}</textarea>
        <label>Description</label>
        <span class="helper-text">
          Press <kbd>Enter</kbd> for multiple lines.
          <a href="https://www.markdownguide.org/cheat-sheet/" target="_blank">Markdown</a> is supported.
        </span>
      </div>
    </div>
    <div class="row submit-row">
      <div class="col s12">
        <button type="submit" class="btn">Publish!</button>
      </div>
    </div>
  </form>

  <script type="text/javascript">
  (function() {
    function debounce(func, wait, immediate) {
      var timeout;
      return function() {
        var context = this, args = arguments;
        var later = function() {
          timeout = null;
          if (!immediate) func.apply(context, args);
        };
        var callNow = immediate && !timeout;
        clearTimeout(timeout);
        timeout = setTimeout(later, wait);
        if (callNow) func.apply(context, args);
      };
    };

    function resetFieldValidation(fieldName) {
      const helpText = document.querySelector(`.input-field.${fieldName} .helper-text`);
      const input =  document.querySelector(`.input-field.${fieldName} input`);
      helpText.removeAttribute('data-error');
      helpText.removeAttribute('data-success');
      input.classList.remove('valid');
      input.classList.remove('invalid');
      input.setCustomValidity('');
    }

    function setFieldError(fieldName, msg) {
      console.log(`setFieldError(${fieldName}, ${msg})`);
      const helpText = document.querySelector(`.input-field.${fieldName} .helper-text`);
      const input =  document.querySelector(`.input-field.${fieldName} input`);
      resetFieldValidation(fieldName);
      helpText.dataset.error = msg;
      input.classList.add('invalid');
      input.setCustomValidity(msg);
    }

    function setFieldSuccess(fieldName, msg) {
      console.log(`setFieldSuccess(${fieldName}, ${msg})`);
      const helpText = document.querySelector(`.input-field.${fieldName} .helper-text`);
      const input =  document.querySelector(`.input-field.${fieldName} input`);
      resetFieldValidation(fieldName);
      helpText.dataset.success = msg;
      input.classList.add('valid');
    }

    const PROJECT_BASE_DOMAIN = '{{ PROJECT_BASE_DOMAIN }}';
    const form = document.querySelector('form');
    const slugField = document.querySelector('input[name="slug"]');
    const submitBtn = document.querySelector('button[type="submit"]');
    const VALID_SUBDOMAIN = new RegExp(/^[a-z0-9](?:[a-z0-9\-]{0,61}[a-z0-9])?$/);
   
    slugField.addEventListener('keypress', event => {
      //slugfield.setCustomValidity('');
      if (!/[a-z0-9-]/.test(event.key)) {
        event.preventDefault();
      }
    });

    slugField.addEventListener('keyup', debounce(async () => {
      if (!slugField.value) return
      if (slugField.value === '{{ formData.slug }}') {
        resetFieldValidation('slug');
        return;
      }

      const available = await domainIsAvailable(slugField.value);
      if (available) {
        setFieldSuccess('slug', `${slugField.value}.${PROJECT_BASE_DOMAIN} is available!`);
      } else {
        setFieldError('slug', `${slugField.value}.${PROJECT_BASE_DOMAIN} is not available`);
      }
    }, 500));

    function cleanDomain() {
      slugField.value = slugField.value.replace(/^-+/, '');
      slugField.value = slugField.value.replace(/-+$/, '');
    }
    slugField.addEventListener('blur', event => {
      cleanDomain();
    });
    slugField.addEventListener('change', async event => {
      cleanDomain();
      if (!slugField.value) {
        setFieldError('slug', 'This field is required.');
      } else if (!slugField.value.match(VALID_SUBDOMAIN)) {
        setFieldError('slug', 'Invalid domain name');
      }
    });

    form.addEventListener('submit', event => {
      // disable submit button, show "please wait..."
      submitBtn.setAttribute('disabled', 'disabled');
      submitBtn.textContent = 'Please wait...';
    });

    async function domainIsAvailable(domain) {
      const res = await fetch(`/api/domain-available/${domain}`);
      if (res.ok) {
        const data = await res.json();
        return data.available;
      } else {
        throw new Error(`Could not fetch domain availability info: ${res.status}: ${res.statusText}`);
      }
    }
  })();
  </script>

{% endif %}
{% endblock %}
